Public Module EpsilonCode
    'Routine to actually run the epsilon determination calculations
    '
    'It accepts its start value and stepping factor from the dialog
    'It must return the value of epsilon and the number of iterations
    'Minimal error checking is performed

    Public Sub EpsilonCalc(ByVal StartValue As Double, ByVal SteppingFactor As Double, ByRef Epsilon As Double, ByRef Iterations As Double)
        'The following variables initialized from the form are available to you.
        ' StartValue = a double precision real value
        ' SteppingFactor =  a double precision real value between 0 and 1

        '!You must specify values for the following two variables before
        ' exiting the subroutine so the form can be updated
        '	Epsilon = a double precision value indicating the machine epsilon
        '	Iterations = an integer indicating the number of times your calculation
        '				looped before finding the answer
        'For an added challenge, make the stop button allow you to exit the subroutine!

        'YOUR CODE STARTS HERE
        Dim it As Integer
        Dim EPS As Double
        it = 0
        EPS = StartValue
        Do While (EPS + 1 > 1)
            EPS = EPS / 2
            it = it + 1
        Loop
        EPS = EPS / SteppingFactor
        Iterations = it
        Epsilon = EPS
        '        !Iterations = 0

        '        !Epsilon = StartValue
        '       !Do()
        '!IF(Epsilon+1 .LE. 1)EXIT
        '           !Iterations = Iterations + 1
        '          !Epsilon = Epsilon * SteppingFactor
        '!END DO'
        '               !Epsilon = 2 * Epsilon

        'YOUR CODE ENDS HERE
    End Sub
End Module
